<?
require_once("include/bittorrent.inc.php");
require_once("include/general_func.inc.php");

dbconn();

loggedinorreturn();

function mask_ip($ip)
{
	return preg_replace('/\.\d+$/', ".xxx", $ip);
}

function dltable($name, $arr, $torrent) {
	
	echo "<b>" . count($arr) . " $name</b>";
	if (count($arr) == 0)
		return;
	
	echo "\n";
	echo "<table border=\"1\" width=\"100%\">\n";
	echo
		"<tr>".
		"<td>User</td>".
		"<td>IP</td>".
		"<td>Listen port</td>".
		"<td>Uploaded in this session</td>".
		"<td>Downloaded in this session</td>".
		"<td>Uploaded total</td>".
		"<td>Downloaded total</td>".
		"<td>Complete</td>".
		"<td>Time connected</td>".
		"<td>Idle</td>".
		"<td>Is connected</td>".
		"</tr>\n";
	
	$now = time();
	
	foreach ($arr as $peer)
	{
		echo "<tr>\n";
		echo "<td>";
		if (currentadmin())
		{
			$res = safequery("SELECT id, username FROM user WHERE id = " . $peer["user_id"]);
			$row = mysql_fetch_array($res);
			echo userlink($row["id"], $row["username"]);
		}
		else
		{
			echo "anonymous";
		}
		
		echo "</td>\n";
		echo "<td>";
		if (currentadmin())
			echo $peer["ip"];
		else
			echo mask_ip($peer["ip"]);
		echo "</td>\r\n";
		
		echo "<td>";
		
		if ($peer["port"] < 1)
		{
			echo "None (passive)";
		}
		else
		{
			echo $peer["port"] . "<br>";
			show_connectable($peer["connectable"] == "yes");
			
			global $CURUSER;
			if ($peer["user_id"] == $CURUSER["id"] || currentadmin())
			{
				echo "<br><font size=\"1\">[<a href=\"test_connectable.php?ip=" . $peer["ip"] . "&port=" . $peer["port"] . "\">force test</a>]</font>";
			}
		}
		
		echo "</td>\r\n";
		
		echo "<td>" . mksize($peer["temp_uploaded"]) . "</td>\n";
		echo "<td>" . mksize($peer["temp_downloaded"]) . "</td>\n";
		echo "<td>" . mksize($peer["temp_uploaded"] + $peer["perm_uploaded"]) . "</td>\n";
		echo "<td>" . mksize($peer["temp_downloaded"] + $peer["perm_downloaded"]) . "</td>\n";
		echo "<td>" . sprintf("%.2f%%", 100 * (1 - ($peer["to_go"] / $torrent["size"]))) . "</td>\n";
		echo "<td>" . mkprettytime($now - $peer["st"]) . "</td>\n";
		echo "<td>" . mkprettytime($now - $peer["la"]) . "</td>\n";
		if ($peer["connected"] == 1)
			$connected = "<font color=\"#00ff00\">yes</font>";
		else
			$connected = "<font color=\"#ff0000\">no</font>";
		echo "<td>" . $connected . "</td>\n";
		echo "</tr>\n";
	}
	echo "</table>\n";
}

if (! ( isset($_GET["id"]) || (intval($_GET["id"]) < 1) ) )
	usererr("Missing ID", "You're missing ID from the URL");

$id = intval($_GET["id"]);

$res = safequery(
	"SELECT 	torrent.seeders, torrent.banned, torrent.leechers, torrent.info_hash, torrent.filename,".
	" 		UNIX_TIMESTAMP() - UNIX_TIMESTAMP(torrent.last_action) AS lastseed, torrent.name, torrent.owner, torrent.save_as, torrent.descr,".
	" 		torrent.visible, torrent.size, torrent.added, torrent.views, torrent.hits, torrent.times_completed, torrent.id, torrent.type,".
	" 		torrent.numfiles, user.id AS owner_id, user.username AS owner_username".
	" FROM		torrent".
	" LEFT JOIN	user ON torrent.owner = user.id".
	" WHERE		torrent.id = $id".
	" LIMIT 1"
	);

$row = mysql_fetch_array($res);
if (!$row)
	usererr("Torrent with ID $id was not found");

$owned = $admin = 0;
if (isset($CURUSER)) {
	if ($CURUSER["admin"] == "yes")
		$owned = $admin = 1;
	elseif ($CURUSER["id"] == $row["owner"])
		$owned = 1;
}

if (!$row || ($row["banned"] == "yes" && !$admin))
	print("no such torrent");
else {
	if (isset($_GET["hit"])) {
		safequery("UPDATE torrent SET views = views + 1 WHERE id = $id");
		if (isset($_GET["tocomm"]))
			header("Refresh: 0; url=details.php?id=$id&page=0#startcomments");
		elseif (isset($_GET["filelist"]))
			header("Refresh: 0; url=details.php?id=$id&filelist=1#filelist");
		elseif (isset($_GET["toseeders"]))
			header("Refresh: 0; url=details.php?id=$id&dllist=1#seeds");
		elseif (isset($_GET["todlers"]))
			header("Refresh: 0; url=details.php?id=$id&dllist=1#leeches");
		else
			header("Refresh: 0; url=details.php?id=$id");
		exit();
	}

	if (!isset($_GET["page"])) {
		stdhead("Details for torrent \"" . $row["name"] . "\"");

		if (isset($CURUSER) && ($CURUSER["id"] == $row["owner"] || $CURUSER["admin"] == "yes"))
			$owned = 1;
		else
			$owned = 0;

		$spacer = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";

		if (isset($_GET["uploaded"])) {
			print("<h2>Successfully uploaded!</h2>\n");
			print("<p>You can start seeding now. <b>Note</b> that the torrent won't be visible until you do that!</p>\n");
		}
		elseif (isset($_GET["searched"])) {
			print("<h2>Your search for \"" . htmlspecialchars($_GET["searched"]) . "\" gave a single result:</h2>\n");
		}

		echo '<center>';
		echo '<table class="table1" align=center cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="60%" border="1"><td>';
		echo '<table class="table1" align=center cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" border="1">';

		$url = "edit.php?id=" . $row["id"];
		if (isset($_GET["returnto"])) {
			$addthis = "&amp;returnto=" . urlencode($_GET["returnto"]);
			$url .= $addthis;
			@$keepget .= $addthis;
		}
		$editlink = "a href=\"$url\" class=\"sublink\"";

		$s = "<b>" . htmlspecialchars($row["name"]) . "</b>";
		if ($owned)
			$s .= " $spacer<$editlink>[Edit torrent]</a>";
		echo '<tr><td align=left colspan="2" class="td1"><span class="text1"'.$s.'</span></td></tr>';

		tr("Filename", "<a class=\"index\" href=\"download.php?id=$id&file=" . rawurlencode($row["filename"]) . "\">" . htmlspecialchars($row["filename"]) . "</a>", 1);
		tr("Downloads as", $row["save_as"]);

		function hex_esc($matches) {
			return sprintf("%02x", ord($matches[0]));
		}
		tr("Info hash", preg_replace_callback('/./s', "hex_esc", hash_pad($row["info_hash"])));

		if (!empty($row["descr"]))
			tr("Description", $row["descr"], 1);
		tr("Availability", show_availability($row["seeders"], $row["leechers"]), 1);
		/*
		if ($row["visible"] == "no")
			tr("Visible", "<b>no</b> (dead)", 1);
		*/
		if ($admin)
			tr("Banned", $row["banned"]);
		
		//old code (only one category)
		/*
			if (isset($row["cat_name"]))
				tr("Type", $row["cat_name"]);
			else
				tr("Type", "(none selected)");
		*/
		
		echo("<tr><td>Categories</td><td>");
		show_categories_by_torrent($id);
		echo("</td></tr>");
		
		tr("Last seeder", "Last activity " . mkprettytime($row["lastseed"]) . " ago");
		tr("Size",mksize($row["size"]) . " (" . $row["size"] . " Bytes)");
		tr("Added", $row["added"]);
		tr("Views", $row["views"]);
		tr("Hits", $row["hits"]);
		tr("Downloaded", $row["times_completed"] . " time(s)");

		$keepget = "";
		//$uprow = isset($row["username"]) ? htmlspecialchars($row["username"]) : "<i>unknown</i>";
		$uprow = userlink($row["owner_id"], $row["owner_username"]);
		if ($owned)
			$uprow .= " $spacer<$editlink>[Edit this torrent]</a>";
		tr("Uploader", $uprow, 1);

		if ($row["type"] == "multi") {
			if (!@$_GET["filelist"])
				tr("Num files<br /><a href=\"details.php?id=$id&amp;filelist=1$keepget#filelist\" class=\"sublink\">[See full list]</a>", $row["numfiles"] . " files", 1);
			else {
				tr("Num files", $row["numfiles"] . " files", 1);

				$s = "<table class=\"table3\" border=\"1\" cellpadding=\"1\" cellspacing=\"0\">\n";

				$subres = safequery("SELECT * FROM file WHERE torrent = $id ORDER BY id");
				while ($subrow = mysql_fetch_array($subres)) {
					$s .= "<tr><td>" . preg_replace(',[^/]+$,', '<b>$0</b>', htmlspecialchars($subrow["filename"])) . "</td><td align=\"right\">" . mksize($subrow["size"]) . "</td></tr>\n";
				}

				$s .= "</table>\n";
				tr("<a name=\"filelist\">File List</a><br /><a href=\"details.php?id=$id$keepget\" class=\"sublink\">[Hide list]</a>", $s, 1);
			}
		}

		if (!@$_GET["dllist"]) {
			tr("Peers<br /><a href=\"details.php?id=$id&amp;dllist=1$keepget#seeds\" class=\"sublink\">[See full list]</a>", $row["seeders"] . " seed(s), " . $row["leechers"] . " leeche(s) = " . ($row["seeders"] + $row["leechers"]) . " peer(s) total", 1);
		}
		else {
			$downloaders = array();
			$seeders = array();
			$subres = safequery("SELECT user_id, seeder, ip, port, temp_uploaded, temp_downloaded, perm_uploaded, perm_downloaded, to_go, UNIX_TIMESTAMP(started) AS st, connectable, UNIX_TIMESTAMP(last_action) AS la, connected FROM peer WHERE torrent = $id");
			while ($subrow = mysql_fetch_array($subres))
			{
				if ($subrow["seeder"] == "yes")
					$seeders[] = $subrow;
				else
					$downloaders[] = $subrow;
			}

			function leech_sort($a,$b)
			{
				$x = $a["to_go"];
				$y = $b["to_go"];
				if ($x == $y)
					return 0;
				if ($x < $y)
					return -1;
				return 1;
			}
			function seed_sort($a,$b)
			{
				$x = $a["temp_uploaded"] + $a["perm_uploaded"];
				$y = $b["temp_uploaded"] + $b["perm_uploaded"];;
				if ($x == $y)
					return 0;
				if ($x < $y)
					return 1;
				return -1;
			}

			usort($seeders, "seed_sort");
			usort($downloaders, "leech_sort");

			echo "<a name=\"seeds\">Seeds</a><br /><a href=\"details.php?id=$id$keepget\" class=\"sublink\">[Hide list]</a><br>";
			dltable("Seeds", $seeders, $row, 1);
			echo "</tr><tr><td><a name=\"leeches\">Leeches</a><br /><a href=\"details.php?id=$id$keepget\" class=\"sublink\">[Hide list]</a></td>";
			echo "<td>";
			dltable("Leeches", $downloaders, $row, 1);
			echo "</td></tr>";
		}

		print("</table></td></table>\n");

		print("<hr />\n");
	}
	else {
		stdhead("Comments for torrent \"" . $row["name"] . "\"");
		print("<p><a href=\"details.php?id=$id\">Back to full details</a></p><hr />\n");
	}

	print("<p><a name=\"startcomments\"></a></p>\n");

	$commentbar = "<p align=\"center\"><a class=\"index\" href=\"addcomment.php?id=$id\">Add a comment</a></p>\n";

	$subres = safequery("SELECT COUNT(*) FROM comment WHERE torrent = $id");
	$subrow = mysql_fetch_array($subres);
	$count = $subrow[0];

	if (!$count) {
		print("<p class=\"important\" align=\"center\">No comments yet</p>\n");
	}
	else {
		list($pagertop, $pagerbottom, $limit) = pager(20, $count, "details.php?id=$id&", array("lastpagedefault" => 1));

		$subres = safequery("SELECT comment.id, text, comment.added, user.username FROM comment LEFT JOIN user ON comment.user = user.id WHERE torrent = $id ORDER BY comment.id $limit");
		$allrows = array();
		while ($subrow = mysql_fetch_array($subres))
			$allrows[] = $subrow;

		print($commentbar);
		print($pagertop);

		commenttable($allrows);

		print($pagerbottom);
	}

	print($commentbar);
}

stdfoot();

?>
